## qtcreator 19.0.0~rc1

=== tests/auto/CMakeLists.txt ===
add_subdirectory(aggregation)
add_subdirectory(algorithm)
add_subdirectory(android)
add_subdirectory(changeset)
add_subdirectory(cplusplus)
add_subdirectory(debugger)
add_subdirectory(diff)
add_subdirectory(environment)
add_subdirectory(examples)
add_subdirectory(extensionsystem)
add_subdirectory(externaltool)
add_subdirectory(filesearch)
add_subdirectory(ios)
add_subdirectory(json)
add_subdirectory(languageserverprotocol)
add_subdirectory(pointeralgorithm)
add_subdirectory(profilewriter)
add_subdirectory(qml)
add_subdirectory(qmldebug)
add_subdirectory(sdktool)
add_subdirectory(solutions)
add_subdirectory(texteditor)
add_subdirectory(toolchaincache)
add_subdirectory(tracing)
add_subdirectory(treeviewfind)
add_subdirectory(updateinfo)
add_subdirectory(utils)
add_subdirectory(valgrind)

if(QTC_USES_INTERNAL_TASKTREE)
  add_subdirectory(qttasktree)
endif()

=== tests/manual/CMakeLists.txt ===
# add_subdirectory(autotoolsprojectmanager)
# add_subdirectory(clang-format-for-qtc)
# add_subdirectory(cplusplus-tools)
# add_subdirectory(cppquickfix)
add_subdirectory(debugger)
add_subdirectory(devcontainer)
add_subdirectory(deviceshell)
# add_subdirectory(distribution)
# add_subdirectory(dockwidgets)
add_subdirectory(fakevim)
# add_subdirectory(features)
# add_subdirectory(filesystemview)
# add_subdirectory(genericproject)
add_subdirectory(pluginview)
add_subdirectory(proparser)
add_subdirectory(terminal)
# add_subdirectory(qml)
# add_subdirectory(qt4projectmanager)
# add_subdirectory(search)
add_subdirectory(shootout)
add_subdirectory(spinner)
add_subdirectory(subdirfilecontainer)
add_subdirectory(widgets)
add_subdirectory(cmdbridge)
add_subdirectory(scripts)

=== src/libs/QtTaskTree/CMakeLists.txt ===
add_subdirectory(QtTaskTree)

=== src/libs/devcontainer/CMakeLists.txt ===
add_qtc_library(DevContainer
  PUBLIC_DEPENDS Qt::Core Utils
  SOURCES
    devcontainer.cpp
    devcontainer.h
    devcontainerconfig.cpp
    devcontainerconfig.h
    devcontainerfeature.cpp
    devcontainerfeature.h
    devcontainer_global.h
    devcontainertr.h
    substitute.cpp
    substitute.h
)

=== src/libs/utils/CMakeLists.txt ===
add_qtc_library(Utils
  DEPENDS Qt::Qml Qt::Sql Qt::Xml Spinner QtCLibArchive
  PUBLIC_DEPENDS
    Qt::Concurrent
    Qt::Core
    Qt::Gui
    Qt::Network
    Qt::PrintSupport
    QtTaskTree
    Qt::Widgets
    $<$<BOOL:${QTC_STATIC_BUILD}>:Spinner>
  SOURCES
    ../3rdparty/span/span.hpp
    ../3rdparty/tl_expected/include/tl/expected.hpp
    action.cpp action.h
    algorithm.h
    ansiescapecodehandler.cpp ansiescapecodehandler.h
    appinfo.cpp appinfo.h
    appmainwindow.cpp appmainwindow.h
    array.h
    aspects.cpp aspects.h
    async.cpp async.h
    basetreeview.cpp basetreeview.h
    benchmarker.cpp benchmarker.h
    buildablehelperlibrary.cpp buildablehelperlibrary.h
    builderutils.h
    camelcasecursor.cpp camelcasecursor.h
    categorysortfiltermodel.cpp categorysortfiltermodel.h
    changeset.cpp changeset.h
    checkablemessagebox.cpp checkablemessagebox.h
    classnamevalidatinglineedit.cpp classnamevalidatinglineedit.h
    clangutils.cpp clangutils.h
    codegeneration.cpp codegeneration.h
    commandline.cpp commandline.h
    completinglineedit.cpp completinglineedit.h
    completingtextedit.cpp completingtextedit.h
    cpplanguage_details.h
    crashreporting.cpp crashreporting.h
    crumblepath.cpp crumblepath.h
    datafromprocess.cpp datafromprocess.h
    delegates.cpp delegates.h
    detailsbutton.cpp detailsbutton.h
    detailswidget.cpp detailswidget.h
    devicefileaccess.cpp devicefileaccess.h
    deviceshell.cpp deviceshell.h
    differ.cpp differ.h
    displayname.cpp displayname.h
    documenttabbar.cpp
    documenttabbar.h
    dropsupport.cpp dropsupport.h
    elfreader.cpp elfreader.h
    elidinglabel.cpp elidinglabel.h
    environment.cpp environment.h
    environmentdialog.cpp environmentdialog.h
    environmentmodel.cpp environmentmodel.h
    environmentfwd.h
    execmenu.cpp execmenu.h
    expected.h
    externalterminalprocessimpl.cpp externalterminalprocessimpl.h
    fadingindicator.cpp fadingindicator.h
    faketooltip.cpp faketooltip.h
    fancyiconbutton.cpp fancyiconbutton.h
    fancylineedit.cpp fancylineedit.h
    fancymainwindow.cpp fancymainwindow.h
    filecrumblabel.cpp filecrumblabel.h
    fileinprojectfinder.cpp fileinprojectfinder.h
    filenamevalidatinglineedit.cpp filenamevalidatinglineedit.h
    filepath.cpp filepath.h
    filepathinfo.h
    filesearch.cpp filesearch.h
    filestreamer.cpp filestreamer.h
    filestreamermanager.cpp filestreamermanager.h
    filesystemwatcher.cpp filesystemwatcher.h
    fileutils.cpp fileutils.h
    filewizardpage.cpp filewizardpage.h
    fsengine/fsengine.cpp fsengine/fsengine.h
    fsengine/fileiconprovider.cpp fsengine/fileiconprovider.h
    futuresynchronizer.cpp futuresynchronizer.h
    fuzzymatcher.cpp fuzzymatcher.h
    genericconstants.h
    globalfilechangeblocker.cpp globalfilechangeblocker.h
    globaltasktree.cpp globaltasktree.h
    guard.cpp guard.h
    guardedcallback.h
    guiutils.cpp guiutils.h
    headerviewstretcher.cpp headerviewstretcher.h
    highlightingitemdelegate.cpp highlightingitemdelegate.h
    historycompleter.cpp historycompleter.h
    hostosinfo.cpp hostosinfo.h
    htmldocextractor.cpp htmldocextractor.h
    icon.cpp icon.h
    icondisplay.h icondisplay.cpp
    id.cpp id.h
    indexedcontainerproxyconstiterator.h
    infobar.cpp infobar.h
    infolabel.cpp infolabel.h
    itemviews.cpp itemviews.h
    jsontreeitem.cpp jsontreeitem.h
    layoutbuilder.cpp layoutbuilder.h
    lazy.h
    link.cpp link.h
    listmodel.h
    listutils.h
    lua.cpp lua.h
    macroexpander.cpp macroexpander.h
    markdownbrowser.cpp markdownbrowser.h
    mathutils.cpp mathutils.h
    mimeconstants.h
    mimeutils.h
    minimizableinfobars.cpp
    minimizableinfobars.h
    multitextcursor.cpp multitextcursor.h
    namevaluedictionary.cpp namevaluedictionary.h
    namevaluedictionary.cpp namevaluedictionary.h
    namevalueitem.cpp namevalueitem.h
    namevaluesdialog.cpp namevaluesdialog.h
    namevaluevalidator.cpp namevaluevalidator.h
    navigationtreeview.cpp navigationtreeview.h
    networkaccessmanager.cpp networkaccessmanager.h
    optionpushbutton.h
    optionpushbutton.cpp
    osspecificaspects.cpp osspecificaspects.h
    outputformat.h
    outputformatter.cpp outputformatter.h
    overlaywidget.cpp overlaywidget.h
    overloaded.h
    overridecursor.cpp overridecursor.h
    passworddialog.cpp passworddialog.h
    pathchooser.cpp pathchooser.h
    pathlisteditor.cpp pathlisteditor.h
    patternvalidator.h
    persistentsettings.cpp persistentsettings.h
    pointeralgorithm.h
    port.cpp port.h
    portlist.cpp portlist.h
    predicates.h
    processenums.h
    processhandle.cpp processhandle.h
    processhelper.cpp processhelper.h
    processinfo.cpp processinfo.h
    processinterface.cpp processinterface.h
    processreaper.cpp processreaper.h
    progressdialog.cpp progressdialog.h
    progressindicator.cpp progressindicator.h
    projectintropage.cpp projectintropage.h
    proxyaction.cpp proxyaction.h
    qrcparser.cpp qrcparser.h
    qtcassert.cpp qtcassert.h
    qtcolorbutton.cpp qtcolorbutton.h
    qtcprocess.cpp qtcprocess.h
    qtcsettings.cpp qtcsettings.h qtcsettings_p.h
    qtcwidgets.cpp qtcwidgets.h
    qtdesignsystemstyle.cpp qtdesignsystemstyle.h
    ranges.h
    reloadpromptutils.cpp reloadpromptutils.h
    removefiledialog.cpp removefiledialog.h
    result.cpp result.h
    savefile.cpp savefile.h
    scopedswap.h
    scopedtimer.cpp scopedtimer.h
    searchresultitem.cpp searchresultitem.h
    set_algorithm.h
    settingsaccessor.cpp settingsaccessor.h
    settingsdatabase.cpp settingsdatabase.h
    shutdownguard.cpp shutdownguard.h
    sizedarray.h
    smallstring.h
    smallstringfwd.h
    smallstringio.h
    smallstringiterator.h
    smallstringlayout.h
    smallstringliteral.h
    smallstringmemory.h
    smallstringvector.h
    smallstringview.h
    sortfiltermodel.h
    span.h
    statuslabel.cpp statuslabel.h
    store.cpp store.h
    storekey.h
    stringtable.cpp stringtable.h
    stringutils.cpp stringutils.h
    styleanimator.cpp styleanimator.h
    styledbar.cpp styledbar.h
    stylehelper.cpp stylehelper.h
    summarywidget.cpp summarywidget.h
    synchronizedvalue.h
    templateengine.cpp templateengine.h
    temporarydirectory.cpp temporarydirectory.h
    temporaryfile.cpp temporaryfile.h
    terminalcommand.cpp terminalcommand.h
    terminalhooks.cpp terminalhooks.h
    terminalinterface.cpp terminalinterface.h
    textcodec.cpp textcodec.h
    textfieldcheckbox.cpp textfieldcheckbox.h
    textfieldcombobox.cpp textfieldcombobox.h
    textfileformat.cpp textfileformat.h
    textutils.cpp textutils.h
    theme/theme.cpp theme/theme.h theme/theme_p.h
    threadutils.cpp threadutils.h
    tooltip/effects.h
    tooltip/tips.cpp tooltip/tips.h
    tooltip/tooltip.cpp tooltip/tooltip.h
    touchbar/touchbar.h
    transientscroll.cpp transientscroll.h
    treemodel.cpp treemodel.h
    treeviewcombobox.cpp treeviewcombobox.h
    unarchiver.cpp unarchiver.h
    uncommentselection.cpp uncommentselection.h
    uniqueobjectptr.h
    unixutils.cpp unixutils.h
    url.cpp url.h
    utils.qrc
    utils_global.h
    utilstr.h
    utilsicons.cpp utilsicons.h
    utiltypes.h
    utility.h
    variablechooser.cpp variablechooser.h
    winutils.cpp winutils.h
    wizard.cpp wizard.h
    wizardpage.cpp wizardpage.h
    movie.cpp movie.h
  SBOM_ARGS
    USE_ATTRIBUTION_FILES
    CREATE_SBOM_FOR_EACH_ATTRIBUTION
    ATTRIBUTION_FILE_PATHS
      "${QtCreator_SOURCE_DIR}/qt_attributions.json"
    ATTRIBUTION_IDS
      std-span-martinmoene
      tartanllama-expected
      tika-mimetypes
)

extend_qtc_library(Utils
  SOURCES_PREFIX mimetypes2
  PUBLIC_INCLUDES mimetypes2
  SOURCES
    mimedatabase.cpp
    mimedatabase.h
    mimedatabase_p.h
    mimeglobpattern.cpp
    mimeglobpattern_p.h
    mimemagicrule.cpp
    mimemagicrule_p.h
    mimemagicrulematcher.cpp
    mimemagicrulematcher_p.h
    mimeprovider.cpp
    mimeprovider_p.h
    mimetype.cpp
    mimetype.h
    mimetype_p.h
    mimetypeparser.cpp
    mimetypeparser_p.h
    mimeutils.cpp
)

extend_qtc_library(Utils
  SOURCES_PREFIX plaintextedit
  PUBLIC_INCLUDES plaintextedit
  SOURCES
    inputcontrol.cpp
    inputcontrol.h
    plaintextedit.cpp
    plaintextedit.h
    plaintexteditaccessibility.cpp
    plaintexteditaccessibility.h
    texteditorlayout.cpp
    texteditorlayout.h
    widgettextcontrol.cpp
    widgettextcontrol.h
)

if (MSVC)
    find_library(DbgHelpLib dbghelp)
endif()

extend_qtc_library(Utils CONDITION MSVC
  DEPENDS ${DbgHelpLib}
  DEFINES HAVE_DBGHELP
)

extend_qtc_library(Utils CONDITION WIN32
  SOURCES
    touchbar/touchbar.cpp
  DEPENDS
    user32 iphlpapi ws2_32 shell32 ole32
  DEFINES
    _UNICODE UNICODE
  PUBLIC_DEFINES
    _CRT_SECURE_NO_WARNINGS _SCL_SECURE_NO_WARNINGS
)

extend_qtc_library(Utils CONDITION APPLE
  SOURCES
    fileutils_mac.mm fileutils_mac.h
    processhandle_mac.mm
    theme/theme_mac.mm theme/theme_mac.h
    touchbar/touchbar_appdelegate_mac.mm touchbar/touchbar_appdelegate_mac_p.h
    touchbar/touchbar_mac.mm touchbar/touchbar_mac_p.h
  DEPENDS
    ${FWFoundation} ${FWAppKit}
)

extend_qtc_library(Utils CONDITION UNIX AND NOT APPLE
  SOURCES
    touchbar/touchbar.cpp
)

extend_qtc_library(Utils
  CONDITION TARGET Qt::CorePrivate
  DEPENDS Qt::CorePrivate ptyqt
  DEFINES QTC_UTILS_WITH_FSENGINE
  SOURCES fsengine/diriterator.h
          fsengine/fileiteratordevicesappender.h
          fsengine/fixedlistfsengine.h
          fsengine/fsenginehandler.cpp
          fsengine/fsenginehandler.h
          fsengine/filepathinfocache.h
  SBOM_ARGS
    ATTRIBUTION_FILE_PATHS
      "${QtCreator_SOURCE_DIR}/qt_attributions.json"
    ATTRIBUTION_IDS
      ptyqt
      ptyqt-conpty
)

extend_qtc_library(Utils
  CONDITION BUILD_WITH_SENTRY
  DEFINES
    SENTRY_DSN="${SENTRY_DSN}"
    SENTRY_PROJECT="${SENTRY_PROJECT}"
    ENABLE_SENTRY
  DEPENDS sentry::sentry
)
extend_qtc_library(Utils
  CONDITION DEFINED SENTRY_CRASHPAD_PATH
  DEFINES
    SENTRY_CRASHPAD_PATH="${SENTRY_CRASHPAD_PATH}"
)

extend_qtc_library(Utils
  CONDITION TARGET Nanotrace
  DEPENDS Nanotrace
)

if (WIN32)
  add_qtc_executable(qtcreator_ctrlc_stub
    DEPENDS user32 shell32
    DEFINES _UNICODE UNICODE _CRT_SECURE_NO_WARNINGS
    SOURCES
      process_ctrlc_stub.cpp
  )
endif()

=== src/plugins/cppeditor/CMakeLists.txt ===
add_qtc_plugin(CppEditor
  DEPENDS Qt::Network Qt::Xml
  PUBLIC_DEPENDS CPlusPlus Qt::Widgets
  PLUGIN_DEPENDS Core ProjectExplorer TextEditor
  PLUGIN_TEST_DEPENDS QbsProjectManager QmakeProjectManager
  SOURCES
    abstracteditorsupport.cpp abstracteditorsupport.h
    baseeditordocumentparser.cpp baseeditordocumentparser.h
    baseeditordocumentprocessor.cpp baseeditordocumentprocessor.h
    builtincursorinfo.cpp builtincursorinfo.h
    builtineditordocumentparser.cpp builtineditordocumentparser.h
    builtineditordocumentprocessor.cpp builtineditordocumentprocessor.h
    clangdiagnosticconfig.cpp clangdiagnosticconfig.h
    clangdiagnosticconfigsmodel.cpp clangdiagnosticconfigsmodel.h
    clangdiagnosticconfigsselectionwidget.cpp clangdiagnosticconfigsselectionwidget.h
    clangdiagnosticconfigswidget.cpp clangdiagnosticconfigswidget.h
    compilationdb.cpp compilationdb.h
    compileroptionsbuilder.cpp compileroptionsbuilder.h
    cppautocompleter.cpp cppautocompleter.h
    cppbuiltinmodelmanagersupport.cpp cppbuiltinmodelmanagersupport.h
    cppcanonicalsymbol.cpp cppcanonicalsymbol.h
    cppchecksymbols.cpp cppchecksymbols.h
    cppcodeformatter.cpp cppcodeformatter.h
    cppcodemodelinspectordialog.cpp cppcodemodelinspectordialog.h
    cppcodemodelinspectordumper.cpp cppcodemodelinspectordumper.h
    cppcodemodelsettings.cpp cppcodemodelsettings.h
    cppcodestylepreferencesfactory.cpp cppcodestylepreferencesfactory.h
    cppcodestylesettings.cpp cppcodestylesettings.h
    cppcodestylesettingspage.cpp cppcodestylesettingspage.h
    cppcodestylesnippets.h
    cppcompletionassist.cpp cppcompletionassist.h
    cppcompletionassistprocessor.cpp cppcompletionassistprocessor.h
    cppcompletionassistprovider.cpp cppcompletionassistprovider.h
    cppcursorinfo.h
    cppdoxygen.cpp cppdoxygen.h
    cppeditor_global.h
    cppeditortr.h
    cppeditorconstants.h
    cppeditordocument.cpp cppeditordocument.h
    cppeditorlogging.cpp cppeditorlogging.h
    cppeditoroutline.cpp cppeditoroutline.h
    cppeditorplugin.cpp
    cppeditorwidget.cpp cppeditorwidget.h
    cppelementevaluator.cpp cppelementevaluator.h
    cppfileiterationorder.cpp cppfileiterationorder.h
    cppfilesettingspage.cpp cppfilesettingspage.h
    cppfindreferences.cpp cppfindreferences.h
    cppfollowsymbolundercursor.cpp cppfollowsymbolundercursor.h
    cppfunctiondecldeflink.cpp cppfunctiondecldeflink.h
    cppfunctionparamrenaminghandler.cpp cppfunctionparamrenaminghandler.h
    cppheadersource.cpp cppheadersource.h
    cpphighlighter.cpp cpphighlighter.h
    cppincludehierarchy.cpp cppincludehierarchy.h
    cppincludesfilter.cpp cppincludesfilter.h
    cppindexingsupport.cpp cppindexingsupport.h
    cpplocalrenaming.cpp cpplocalrenaming.h
    cpplocalsymbols.cpp cpplocalsymbols.h
    cpplocatordata.cpp cpplocatordata.h
    cpplocatorfilter.cpp cpplocatorfilter.h
    cppmodelmanager.cpp cppmodelmanager.h
    cppmodelmanagersupport.cpp cppmodelmanagersupport.h
    cppoutline.cpp cppoutline.h
    cppoutlinemodel.cpp cppoutlinemodel.h
    cppparsecontext.cpp cppparsecontext.h
    cpppointerdeclarationformatter.cpp cpppointerdeclarationformatter.h
    cpppreprocessordialog.cpp cpppreprocessordialog.h
    cppprojectfile.cpp cppprojectfile.h
    cppprojectfilecategorizer.cpp cppprojectfilecategorizer.h
    cppprojectinfogenerator.cpp cppprojectinfogenerator.h
    cppprojectpartchooser.cpp cppprojectpartchooser.h
    cppprojectupdater.cpp cppprojectupdater.h
    cppqtstyleindenter.cpp cppqtstyleindenter.h
    cpprefactoringchanges.cpp cpprefactoringchanges.h
    cppselectionchanger.cpp cppselectionchanger.h
    cppsemanticinfo.h
    cppsemanticinfoupdater.cpp cppsemanticinfoupdater.h
    cppsourceprocessor.cpp cppsourceprocessor.h
    cpptoolsjsextension.cpp cpptoolsjsextension.h
    cpptoolsreuse.cpp cpptoolsreuse.h
    cpptoolssettings.cpp cpptoolssettings.h
    cpptypehierarchy.cpp cpptypehierarchy.h
    cppuseselectionsupdater.cpp cppuseselectionsupdater.h
    cppvirtualfunctionassistprovider.cpp cppvirtualfunctionassistprovider.h
    cppvirtualfunctionproposalitem.cpp cppvirtualfunctionproposalitem.h
    cppworkingcopy.cpp cppworkingcopy.h
    clangdsettings.cpp clangdsettings.h
    cursorineditor.h
    doxygengenerator.cpp doxygengenerator.h
    editordocumenthandle.cpp editordocumenthandle.h
    functionutils.cpp functionutils.h
    generatedcodemodelsupport.cpp generatedcodemodelsupport.h
    headerpathfilter.cpp headerpathfilter.h
    includeutils.cpp includeutils.h
    indexitem.cpp indexitem.h
    insertionpointlocator.cpp insertionpointlocator.h
    projectinfo.cpp projectinfo.h
    projectpart.cpp projectpart.h
    quickfixes/addmodulefrominclude.cpp quickfixes/addmodulefrominclude.h
    quickfixes/assigntolocalvariable.cpp quickfixes/assigntolocalvariable.h
    quickfixes/bringidentifierintoscope.cpp quickfixes/bringidentifierintoscope.h
    quickfixes/completeswitchstatement.cpp quickfixes/completeswitchstatement.h
    quickfixes/convertnumericliteral.cpp quickfixes/convertnumericliteral.h
    quickfixes/convertqt4connect.cpp quickfixes/convertqt4connect.h
    quickfixes/convertstringliteral.cpp quickfixes/convertstringliteral.h
    quickfixes/converttocamelcase.cpp quickfixes/converttocamelcase.h
    quickfixes/converttometamethodcall.cpp quickfixes/converttometamethodcall.h
    quickfixes/cppcodegenerationquickfixes.cpp quickfixes/cppcodegenerationquickfixes.h
    quickfixes/cppinsertvirtualmethods.cpp quickfixes/cppinsertvirtualmethods.h
    quickfixes/cppquickfix.cpp quickfixes/cppquickfix.h
    quickfixes/cppquickfixassistant.cpp quickfixes/cppquickfixassistant.h
    quickfixes/cppquickfixhelpers.h quickfixes/cppquickfixhelpers.cpp
    quickfixes/cppquickfixprojectsettings.cpp quickfixes/cppquickfixprojectsettings.h
    quickfixes/cppquickfixprojectsettingswidget.cpp quickfixes/cppquickfixprojectsettingswidget.h
    quickfixes/cppquickfixsettings.cpp quickfixes/cppquickfixsettings.h
    quickfixes/cppquickfixsettingspage.cpp quickfixes/cppquickfixsettingspage.h
    quickfixes/cppquickfixsettingswidget.cpp quickfixes/cppquickfixsettingswidget.h
    quickfixes/convertfromandtopointer.cpp quickfixes/convertfromandtopointer.h
    quickfixes/createdeclarationfromuse.cpp quickfixes/createdeclarationfromuse.h
    quickfixes/extractfunction.cpp quickfixes/extractfunction.h
    quickfixes/extractliteralasparameter.cpp quickfixes/extractliteralasparameter.h
    quickfixes/insertfunctiondefinition.cpp quickfixes/insertfunctiondefinition.h
    quickfixes/logicaloperationquickfixes.cpp quickfixes/logicaloperationquickfixes.h
    quickfixes/moveclasstoownfile.cpp quickfixes/moveclasstoownfile.h
    quickfixes/movefunctiondefinition.cpp quickfixes/movefunctiondefinition.h
    quickfixes/rearrangeparamdeclarationlist.cpp quickfixes/rearrangeparamdeclarationlist.h
    quickfixes/reformatpointerdeclaration.cpp quickfixes/reformatpointerdeclaration.h
    quickfixes/removeusingnamespace.cpp quickfixes/removeusingnamespace.h
    quickfixes/rewritecomment.cpp quickfixes/rewritecomment.cpp
    quickfixes/rewritecontrolstatements.cpp quickfixes/rewritecontrolstatements.h
    quickfixes/splitsimpledeclaration.cpp quickfixes/splitsimpledeclaration.h
    quickfixes/synchronizememberfunctionorder.cpp quickfixes/synchronizememberfunctionorder.h
    searchsymbols.cpp searchsymbols.h
    semantichighlighter.cpp semantichighlighter.h
    symbolfinder.cpp symbolfinder.h
    symbolsfindfilter.cpp symbolsfindfilter.h
    typehierarchybuilder.cpp typehierarchybuilder.h
    wrappablelineedit.cpp wrappablelineedit.h
   EXPLICIT_MOC
     quickfixes/cppquickfixsettingswidget.h
)

extend_qtc_plugin(CppEditor
  CONDITION WITH_TESTS
  SOURCES
    compileroptionsbuilder_test.cpp compileroptionsbuilder_test.h
    cppcodegen_test.cpp cppcodegen_test.h
    cppcompletion_test.cpp cppcompletion_test.h
    cppdoxygen_test.cpp cppdoxygen_test.h
    cppincludehierarchy_test.cpp cppincludehierarchy_test.h
    cpplocalsymbols_test.cpp cpplocalsymbols_test.h
    cpplocatorfilter_test.cpp cpplocatorfilter_test.h
    cppmodelmanager_test.cpp cppmodelmanager_test.h
    cpppointerdeclarationformatter_test.cpp cpppointerdeclarationformatter_test.h
    cpprenaming_test.cpp cpprenaming_test.h
    cppsourceprocessertesthelper.cpp cppsourceprocessertesthelper.h
    cppsourceprocessor_test.cpp cppsourceprocessor_test.h
    cpptoolstestcase.cpp cpptoolstestcase.h
    cppuseselections_test.cpp cppuseselections_test.h
    fileandtokenactions_test.cpp fileandtokenactions_test.h
    followsymbol_switchmethoddecldef_test.cpp followsymbol_switchmethoddecldef_test.h
    modelmanagertesthelper.cpp modelmanagertesthelper.h
    projectinfo_test.cpp projectinfo_test.h
    quickfixes/cppquickfix_test.cpp quickfixes/cppquickfix_test.h
    symbolsearcher_test.cpp symbolsearcher_test.h
    typehierarchybuilder_test.cpp typehierarchybuilder_test.h
  EXPLICIT_MOC
    cppdoxygen_test.h
    quickfixes/cppquickfix_test.h
)

qtc_add_resources(CppEditor "images"
  PREFIX "/cppeditor"
  BASE "."
  FILES
    images/dark_qt_c.png
    images/dark_qt_cpp.png
    images/dark_qt_h.png
)
file(GLOB_RECURSE test_cases RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} testcases/*)
qtc_add_resources(CppEditor "testcases"
  CONDITION WITH_TESTS
  PREFIX "/cppeditor"
  BASE "."
  FILES ${test_cases}
)

=== src/plugins/glsleditor/CMakeLists.txt ===
add_qtc_plugin(GLSLEditor
  PLUGIN_CLASS GlslEditorPlugin
  DEPENDS GLSL
  PLUGIN_DEPENDS Core CppEditor TextEditor
  SOURCES
    glslautocompleter.cpp glslautocompleter.h
    glslcompletionassist.cpp glslcompletionassist.h
    glsleditor.cpp glsleditor.h
    glsleditorconstants.h
    glsleditorplugin.cpp
    glsleditortr.h
    glslhighlighter.cpp glslhighlighter.h
    glslindenter.cpp glslindenter.h
)

file(GLOB_RECURSE images RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} images/*)
qtc_add_resources(GLSLEditor "images"
  PREFIX "/glsleditor"
  BASE "."
  FILES ${images}
)

=== src/plugins/qmldesigner/CMakeLists.txt ===
#only if the plugin is requested by qtc_plugin_enabled continue if not stop as early as possible

set(QmlDesignerPluginInstallPrefix "${IDE_PLUGIN_PATH}/qmldesigner")
if (APPLE)
  set(QmlDesignerPluginInstallPrefix "${IDE_PLUGIN_PATH}/QmlDesigner")
endif()

option(USE_PROJECTSTORAGE "Use ProjectStorage" OFF)
add_feature_info("Use project storage" ${USE_PROJECTSTORAGE} "")

option(DETACH_DISABLED_VIEWS "Detach disabled views" ${BUILD_DESIGNSTUDIO})

# temporary workaround for broken QML imports in Qt -> Qt 6.9.2 should work without this
env_with_default(QTC_USE_QML_IMPORT_OVERRIDE ENV_QTC_USE_QML_IMPORT_OVERRIDE ${BUILD_DESIGNSTUDIO})
option(USE_QML_IMPORT_OVERRIDE "Use Qml import override from resource path." ${ENV_QTC_USE_QML_IMPORT_OVERRIDE})

if(USE_QML_IMPORT_OVERRIDE)
  include(FetchContent)
  FetchContent_Declare(qds_qml_import_override
      GIT_REPOSITORY https://git.qt.io/design-studio/qds-qml-import-override.git
      GIT_TAG        qds-4.8.0-beta1
      SOURCE_DIR     "${PROJECT_BINARY_DIR}/${IDE_DATA_PATH}/qmldesigner/qml-import-override"
  )
  FetchContent_MakeAvailable(qds_qml_import_override)
  install(DIRECTORY "${qds_qml_import_override_SOURCE_DIR}/"
          DESTINATION "${IDE_DATA_PATH}/qmldesigner/qml-import-override"
          PATTERN ".git" EXCLUDE
          PATTERN ".gitignore" EXCLUDE
          PATTERN ".gitattributes" EXCLUDE)
endif()

if(QDS_DESIGNVIEWER_USE_STAGING)
  add_definitions(-DQDS_DESIGNVIEWER_USE_STAGING)
endif()

add_subdirectory(libs)

add_qtc_library(QmlDesignerSettings STATIC
  DEPENDS Utils
  PUBLIC_INCLUDES settings
  SOURCES_PREFIX settings
  SOURCES
    qmldesignersettings_global.h
    designersettings.cpp designersettings.h
)

add_qtc_plugin(QmlDesigner
  PLUGIN_RECOMMENDS QmlPreview
  CONDITION TARGET QmlDesignerCore AND TARGET Qt::QuickWidgets AND TARGET Qt::Svg
  PLUGIN_DEPENDS
    Core
    ProjectExplorer
    QmlJSEditor
    QmakeProjectManager
    QmlProjectManager
    QtSupport
    TextEditor
  DEPENDS
    QmlJS LanguageUtils QmlEditorWidgets AdvancedDockingSystem
    Qt::QuickWidgets Qt::CorePrivate Qt::Xml Qt::Svg Sqlite Qt::GuiPrivate
    Qt::Core Qt::GuiPrivate
  PUBLIC_DEPENDS
    QmlDesignerUtils QmlPuppetCommunication QmlDesignerCore DesignSystem
  DEFINES
    IDE_LIBRARY_BASENAME=\"${IDE_LIBRARY_BASE_PATH}\"
    SHARE_QML_PATH="${CMAKE_CURRENT_SOURCE_DIR}/../../../share/qtcreator/qmldesigner"
    $<$<BOOL:${DETACH_DISABLED_VIEWS}>:DETACH_DISABLED_VIEWS>
  PUBLIC_DEFINES
    $<$<BOOL:${USE_PROJECTSTORAGE}>:QDS_USE_PROJECTSTORAGE>
    $<$<BOOL:${USE_QML_IMPORT_OVERRIDE}>:USE_QML_IMPORT_OVERRIDE>
  INCLUDES
    ${CMAKE_CURRENT_LIST_DIR}/libs
    ${CMAKE_CURRENT_LIST_DIR}/components
    ${CMAKE_CURRENT_LIST_DIR}/components/import3d
    ${CMAKE_CURRENT_LIST_DIR}/components/assetslibrary
    ${CMAKE_CURRENT_LIST_DIR}/components/debugview
    ${CMAKE_CURRENT_LIST_DIR}/components/designsystemview
    ${CMAKE_CURRENT_LIST_DIR}/components/edit3d
    ${CMAKE_CURRENT_LIST_DIR}/components/formeditor
    ${CMAKE_CURRENT_LIST_DIR}/components/integration
    ${CMAKE_CURRENT_LIST_DIR}/components/itemlibrary
    ${CMAKE_CURRENT_LIST_DIR}/components/materialbrowser
    ${CMAKE_CURRENT_LIST_DIR}/components/navigator
    ${CMAKE_CURRENT_LIST_DIR}/components/propertyeditor
    ${CMAKE_CURRENT_LIST_DIR}/components/stateseditor
    ${CMAKE_CURRENT_LIST_DIR}/components/texteditor
    ${CMAKE_CURRENT_LIST_DIR}/components/designsystem
  PUBLIC_INCLUDES
    ${CMAKE_CURRENT_LIST_DIR}
    ${CMAKE_CURRENT_LIST_DIR}/components
    ${CMAKE_CURRENT_LIST_DIR}/settings
  SOURCES
    designmodewidget.cpp designmodewidget.h
    documentmanager.cpp documentmanager.h
    documentwarningwidget.cpp documentwarningwidget.h
    openuiqmlfiledialog.cpp openuiqmlfiledialog.h
    puppetenvironmentbuilder.cpp puppetenvironmentbuilder.h
    qmldesigner_global.h
    qmldesignerconstants.h
    qmldesignericons.h
    qmldesignerplugin.cpp qmldesignerplugin.h
    qmldesignerexternaldependencies.cpp qmldesignerexternaldependencies.h
    settingspage.cpp settingspage.h
    shortcutmanager.cpp shortcutmanager.h
    designermcumanager.cpp designermcumanager.h
    richtexteditordialog.cpp richtexteditordialog.h
    editorproxy.cpp editorproxy.h
  EXPLICIT_MOC
    components/propertyeditor/propertyeditorvalue.h
    qmldesignerplugin.h
  EXTRA_TRANSLATIONS
    "${PROJECT_SOURCE_DIR}/share/qtcreator/qmldesigner"
  PROPERTIES
    QMLDESIGNER_PLUGIN_PATH "${QmlDesignerPluginInstallPrefix}"
)

extend_qtc_plugin(QmlDesigner
    CONDITION ENABLE_COMPILE_WARNING_AS_ERROR
    PROPERTIES COMPILE_WARNING_AS_ERROR ON
    PUBLIC_COMPILE_OPTIONS $<$<COMPILE_LANG_AND_ID:CXX,Clang,GNU>:-Wno-error=maybe-uninitialized>
)

if (QTC_STATIC_BUILD AND TARGET QmlDesigner)
  get_target_property(_designerType Qt::Designer TYPE)
  if (${_designerType} STREQUAL "STATIC_LIBRARY")
    extend_qtc_target(QmlDesigner PUBLIC_DEFINES QT_DESIGNER_STATIC)
  endif()
  extend_qtc_target(QmlDesigner PUBLIC_DEPENDS TextEditor)
endif()

extend_qtc_plugin(QmlDesigner
  PUBLIC_INCLUDES project
  SOURCES_PREFIX project
  SOURCES
   qmldesignerprojectmanager.cpp
   qmldesignerprojectmanager.h
   projectstorageerrornotifier.cpp
   projectstorageerrornotifier.h
)

extend_qtc_plugin(QmlDesigner
  PUBLIC_INCLUDES instances
  SOURCES_PREFIX instances
  SOURCES
    baseconnectionmanager.cpp
    baseconnectionmanager.h
    capturingconnectionmanager.cpp
    capturingconnectionmanager.h
    connectionmanager.cpp
    connectionmanager.h
    connectionmanagerinterface.cpp
    connectionmanagerinterface.h
    interactiveconnectionmanager.cpp
    interactiveconnectionmanager.h
    nodeinstance.cpp
    nodeinstance.h
    nodeinstanceserverproxy.cpp
    nodeinstanceserverproxy.h
    nodeinstanceview.cpp
    nodeinstanceview.h
    puppetstarter.cpp
    puppetstarter.h
    qprocessuniqueptr.h
)

extend_qtc_plugin(QmlDesigner
  PUBLIC_INCLUDES qmltools
  SOURCES_PREFIX qmltools
  SOURCES
    anchorline.cpp
    anchorline.h
    qml3dnode.cpp
    qml3dnode.h
    qmlanchors.cpp
    qmlanchors.h
    qmlchangeset.cpp
    qmlchangeset.h
    qmlconnections.cpp
    qmlconnections.h
    qmlitemnode.cpp
    qmlitemnode.h
    qmlmodelnodefacade.cpp
    qmlmodelnodefacade.h
    qmlobjectnode.cpp
    qmlobjectnode.h
    qmlstate.cpp
    qmlstate.h
    qmltimeline.cpp
    qmltimeline.h
    qmltimelinekeyframegroup.cpp
    qmltimelinekeyframegroup.h
    qmlvisualnode.cpp
    qmlvisualnode.h
)

extend_qtc_plugin(QmlDesigner
  SOURCES_PREFIX components/componentcore
  PUBLIC_INCLUDES components/componentcore
  DEFINES QMLDESIGNERCOMPONENTS_LIBRARY
  SOURCES
    abstractaction.cpp abstractaction.h
    abstractactiongroup.cpp abstractactiongroup.h
    actioninterface.h
    addimagesdialog.cpp addimagesdialog.h
    addsignalhandlerdialog.cpp addsignalhandlerdialog.h addsignalhandlerdialog.ui
    bundlehelper.cpp bundlehelper.h
    bundleimporter.cpp bundleimporter.h
    changestyleaction.cpp changestyleaction.h
    componentcore.qrc
    componentcore_constants.h
    createtexture.cpp createtexture.h
    crumblebar.cpp crumblebar.h
    designeractionmanager.cpp designeractionmanager.h
    designeractionmanagerview.cpp designeractionmanagerview.h
    designericons.cpp designericons.h
    findimplementation.cpp findimplementation.h
    groupitemaction.cpp groupitemaction.h
    layoutingridlayout.cpp layoutingridlayout.h
    modelnodecontextmenu.cpp modelnodecontextmenu.h
    modelnodecontextmenu_helper.cpp modelnodecontextmenu_helper.h
    modelnodeoperations.cpp modelnodeoperations.h
    formatoperation.cpp formatoperation.h
    navigation2d.cpp navigation2d.h
    propertyeditorcomponentgenerator.cpp propertyeditorcomponentgenerator.h
    propertycomponentgenerator.cpp propertycomponentgenerator.h
    propertycomponentgeneratorinterface.h
    qmldesignercomponents_global.h
    qmldesignericonprovider.cpp qmldesignericonprovider.h
    qmleditormenu.cpp qmleditormenu.h
    selectioncontext.cpp selectioncontext.h
    theme.cpp theme.h
    zoomaction.cpp zoomaction.h
    anchoraction.cpp anchoraction.h
    svgpasteaction.cpp svgpasteaction.h
    viewmanager.cpp viewmanager.h
    utils3d.cpp utils3d.h
    dialogutils.cpp dialogutils.h
    modelnodeutils.cpp modelnodeutils.h
)

extend_qtc_plugin(QmlDesigner
  SOURCES_PREFIX components/debugview
  SOURCES
    debugview.cpp debugview.h
    debugviewwidget.cpp debugviewwidget.h debugviewwidget.ui
)

extend_qtc_plugin(QmlDesigner
  SOURCES_PREFIX components/designsystemview
  SOURCES
    collectionmodel.h collectionmodel.cpp
    designsysteminterface.h designsysteminterface.cpp
    designsystemview.cpp designsystemview.h
    designsystemwidget.cpp designsystemwidget.h
)

extend_qtc_plugin(QmlDesigner
  SOURCES_PREFIX components/edit3d
  SOURCES
  edit3dview.cpp edit3dview.h
  edit3dviewconfig.h
  edit3dwidget.cpp edit3dwidget.h
  edit3dcanvas.cpp edit3dcanvas.h
  edit3dactions.cpp edit3dactions.h
  edit3dmaterialsaction.cpp edit3dmaterialsaction.h
  edit3dtoolbarmenu.cpp edit3dtoolbarmenu.h
  backgroundcolorselection.cpp backgroundcolorselection.h
  bakelights.cpp bakelights.h
  indicatoractionwidget.cpp indicatoractionwidget.h
  snapconfiguration.cpp snapconfiguration.h
  cameraspeedconfiguration.cpp cameraspeedconfiguration.h
  bakelightsdatamodel.cpp bakelightsdatamodel.h
  bakelightsconnectionmanager.cpp bakelightsconnectionmanager.h
  edit3d.qrc
)

extend_qtc_plugin(QmlDesigner
  SOURCES_PREFIX components/formeditor
  PUBLIC_INCLUDES components/formeditor
  PUBLIC_DEFINES
    $<$<BOOL:${ENABLE_FORM_EDITOR_TRACING}>:ENABLE_FORM_EDITOR_TRACING>
  SOURCES
    abstractcustomtool.cpp abstractcustomtool.h
    abstractformeditortool.cpp abstractformeditortool.h
    anchorindicator.cpp anchorindicator.h
    anchorindicatorgraphicsitem.cpp anchorindicatorgraphicsitem.h
    backgroundaction.cpp backgroundaction.h
    bindingindicator.cpp bindingindicator.h
    bindingindicatorgraphicsitem.cpp bindingindicatorgraphicsitem.h
    controlelement.cpp controlelement.h
    dragtool.cpp dragtool.h
    formeditor.qrc
    formeditorannotationicon.cpp formeditorannotationicon.h
    formeditorgraphicsview.cpp formeditorgraphicsview.h
    formeditoritem.cpp formeditoritem.h
    formeditorscene.cpp formeditorscene.h
    formeditortracing.cpp formeditortracing.h
    formeditorsubwindow.h
    formeditortoolbutton.cpp formeditortoolbutton.h
    formeditorview.cpp formeditorview.h
    formeditorwidget.cpp formeditorwidget.h
    itemutilfunctions.cpp itemutilfunctions.h
    layeritem.cpp layeritem.h
    lineeditaction.cpp lineeditaction.h
    movemanipulator.cpp movemanipulator.h
    movetool.cpp movetool.h
    onedimensionalcluster.cpp onedimensionalcluster.h
    resizecontroller.cpp resizecontroller.h
    resizehandleitem.cpp resizehandleitem.h
    resizeindicator.cpp resizeindicator.h
    resizemanipulator.cpp resizemanipulator.h
    resizetool.cpp resizetool.h
    rotationtool.cpp rotationtool.h
    rotationindicator.cpp rotationindicator.h
    rotationcontroller.cpp rotationcontroller.h
    rotationhandleitem.cpp rotationhandleitem.h
    rotationmanipulator.cpp rotationmanipulator.h
    rubberbandselectionmanipulator.cpp rubberbandselectionmanipulator.h
    scaleitem.cpp scaleitem.h
    scalemanipulator.cpp scalemanipulator.h
    seekerslider.cpp seekerslider.h
    selectionindicator.cpp selectionindicator.h
    selectionrectangle.cpp selectionrectangle.h
    selectiontool.cpp selectiontool.h
    singleselectionmanipulator.cpp singleselectionmanipulator.h
    snapper.cpp snapper.h
    snappinglinecreator.cpp snappinglinecreator.h
    toolbox.cpp toolbox.h
    view3dtool.cpp view3dtool.h
)

extend_qtc_plugin(QmlDesigner
  SOURCES_PREFIX components/integration
  PUBLIC_INCLUDES components/integration
  SOURCES
    componentaction.cpp componentaction.h
    componentview.cpp componentview.h
    designdocument.cpp designdocument.h
    designdocumentview.cpp designdocumentview.h

=== src/plugins/texteditor/CMakeLists.txt ===
if(TARGET KSyntaxHighlighting)
  set(KSYNTAXHIGHLIGHTING_TARGET KSyntaxHighlighting)
else()
  set(KSYNTAXHIGHLIGHTING_TARGET KF5::SyntaxHighlighting)
endif()

add_qtc_library(TextEditorSupport STATIC
  DEPENDS Utils
  SOURCES
    texteditorsupport_global.h
    tabsettings.cpp tabsettings.h
)

add_qtc_plugin(TextEditor
  DEPENDS Qt::Concurrent Qt::Network Qt::PrintSupport Qt::Xml
  PUBLIC_DEPENDS ${KSYNTAXHIGHLIGHTING_TARGET}
  PLUGIN_DEPENDS Core
  SOURCES
    autocompleter.cpp autocompleter.h
    basefilefind.cpp basefilefind.h
    basehoverhandler.cpp basehoverhandler.h
    behaviorsettings.cpp behaviorsettings.h
    behaviorsettingspage.cpp behaviorsettingspage.h
    behaviorsettingswidget.cpp behaviorsettingswidget.h
    blockrange.h
    bookmark.cpp bookmark.h
    bookmarkfilter.cpp bookmarkfilter.h
    bookmarkmanager.cpp bookmarkmanager.h
    circularclipboard.cpp circularclipboard.h
    circularclipboardassist.cpp circularclipboardassist.h
    codeassist/assistenums.h
    codeassist/assistinterface.cpp codeassist/assistinterface.h
    codeassist/assistproposalitem.cpp codeassist/assistproposalitem.h
    codeassist/assistproposaliteminterface.h
    codeassist/asyncprocessor.cpp codeassist/asyncprocessor.h
    codeassist/codeassistant.cpp codeassist/codeassistant.h
    codeassist/completionassistprovider.cpp codeassist/completionassistprovider.h
    codeassist/documentcontentcompletion.cpp codeassist/documentcontentcompletion.h
    codeassist/functionhintproposal.cpp codeassist/functionhintproposal.h
    codeassist/functionhintproposalwidget.cpp codeassist/functionhintproposalwidget.h
    codeassist/genericproposal.cpp codeassist/genericproposal.h
    codeassist/genericproposalmodel.cpp codeassist/genericproposalmodel.h
    codeassist/genericproposalwidget.cpp codeassist/genericproposalwidget.h
    codeassist/iassistprocessor.cpp codeassist/iassistprocessor.h
    codeassist/iassistproposal.cpp codeassist/iassistproposal.h
    codeassist/iassistproposalmodel.cpp codeassist/iassistproposalmodel.h
    codeassist/iassistproposalwidget.cpp codeassist/iassistproposalwidget.h
    codeassist/iassistprovider.cpp codeassist/iassistprovider.h
    codeassist/ifunctionhintproposalmodel.cpp codeassist/ifunctionhintproposalmodel.h
    codeassist/keywordscompletionassist.cpp codeassist/keywordscompletionassist.h
    codecchooser.cpp codecchooser.h
    codestyleeditor.cpp codestyleeditor.h
    codestylepool.cpp codestylepool.h
    codestyleselectorwidget.cpp codestyleselectorwidget.h
    colorpreviewhoverhandler.cpp colorpreviewhoverhandler.h
    colorscheme.cpp colorscheme.h
    colorschemeedit.cpp colorschemeedit.h
    command.cpp command.h
    commentssettings.cpp commentssettings.h
    completionsettings.cpp completionsettings.h
    completionsettingspage.cpp completionsettingspage.h
    displaysettings.cpp displaysettings.h
    displaysettingspage.cpp displaysettingspage.h
    extraencodingsettings.cpp extraencodingsettings.h
    findincurrentfile.cpp findincurrentfile.h
    findinfiles.cpp findinfiles.h
    findinopenfiles.cpp findinopenfiles.h
    fontsettings.cpp fontsettings.h
    fontsettingspage.cpp fontsettingspage.h
    formatter.h
    formattexteditor.cpp formattexteditor.h
    highlighter.cpp highlighter.h
    highlighterhelper.cpp highlighterhelper.h
    highlightersettings.cpp highlightersettings.h
    highlightersettingspage.cpp highlightersettingspage.h
    icodestylepreferences.cpp icodestylepreferences.h
    icodestylepreferencesfactory.h
    indenter.h
    ioutlinewidget.h
    jsoneditor.cpp jsoneditor.h
    linenumberfilter.cpp linenumberfilter.h
    marginsettings.cpp marginsettings.h
    markdowneditor.cpp markdowneditor.h
    outlinefactory.cpp outlinefactory.h
    plaintexteditorfactory.cpp plaintexteditorfactory.h
    quickfix.cpp quickfix.h
    refactoringchanges.cpp refactoringchanges.h
    refactoroverlay.cpp refactoroverlay.h
    semantichighlighter.cpp semantichighlighter.h
    simplecodestylepreferences.cpp simplecodestylepreferences.h
    simplecodestylepreferenceswidget.cpp simplecodestylepreferenceswidget.h
    snippets/reuse.h
    snippets/snippet.cpp snippets/snippet.h
    snippets/snippetassistcollector.cpp snippets/snippetassistcollector.h
    snippets/snippeteditor.cpp snippets/snippeteditor.h
    snippets/snippetoverlay.cpp snippets/snippetoverlay.h
    snippets/snippetparser.cpp snippets/snippetparser.h
    snippets/snippetprovider.cpp snippets/snippetprovider.h
    snippets/snippetscollection.cpp snippets/snippetscollection.h
    snippets/snippetssettingspage.cpp snippets/snippetssettingspage.h
    storagesettings.cpp storagesettings.h
    syntaxhighlighter.cpp syntaxhighlighter.h
    tabsettingswidget.cpp tabsettingswidget.h
    textdocument.cpp textdocument.h
    textdocumentlayout.cpp textdocumentlayout.h
    texteditor.cpp texteditor.h
    texteditor_global.h
    texteditorconstants.cpp texteditorconstants.h
    texteditoroverlay.cpp texteditoroverlay.h
    texteditorplugin.cpp
    texteditorsettings.cpp texteditorsettings.h
    texteditortr.h
    textindenter.cpp textindenter.h
    textmark.cpp textmark.h
    textstyles.h
    textsuggestion.h textsuggestion.cpp
    typehierarchy.cpp typehierarchy.h
    typingsettings.cpp typingsettings.h
)

extend_qtc_plugin(TextEditor
  CONDITION WITH_TESTS
  SOURCES
    codeassist/codeassist_test.cpp
    codeassist/codeassist_test.h
    highlighter_test.cpp
    highlighter_test.h
    texteditor_test.cpp
    texteditor_test.h
)

qtc_add_resources(TextEditor "images"
  PREFIX "/texteditor"
  BASE "."
  FILES
    images/finddocuments.png
    images/settingscategory_texteditor.png
    images/settingscategory_texteditor@2x.png
    images/snippet.png
)

# from cmake 3.24 $<LINK_LIBRARY:WHOLE_ARCHIVE,TextEditorSupport> is supported which can be added to DEPENDS
if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.24.0" AND NOT CMAKE_GENERATOR STREQUAL "FASTBuild")
  target_link_libraries(TextEditor PRIVATE $<LINK_LIBRARY:WHOLE_ARCHIVE,TextEditorSupport>)
else ()
  if (MSVC)
    qtc_output_binary_dir(_output_binary_dir)
    set_target_properties(TextEditor PROPERTIES LINK_FLAGS "/WHOLEARCHIVE:${_output_binary_dir}/${IDE_BIN_PATH}/TextEditorSupport.lib")
  elseif (APPLE)
    target_link_libraries(TextEditor PRIVATE -Wl,-force_load "$<TARGET_LINKER_FILE:TextEditorSupport>")
  else ()
    target_link_libraries(TextEditor PRIVATE -Wl,--whole-archive $<TARGET_LINKER_FILE:TextEditorSupport> -Wl,--no-whole-archive)
  endif ()
endif ()

=== src/tools/qmlpuppet/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20)

# standalone build
if (NOT QT_CREATOR_API_DEFINED)
    option(BUILD_DESIGNSTUDIO "Build QML Puppet with Qt Design Studio version in the binary name." OFF)
    if (BUILD_DESIGNSTUDIO)
        list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../../../dist/branding/qtdesignstudio")
    endif()
  list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../../../cmake")

  project(qmlpuppet)

  set(CMAKE_AUTOMOC ON)
  set(CMAKE_AUTORCC ON)
  set(CMAKE_AUTOUIC ON)
  set(CMAKE_CXX_STANDARD 20)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
  set(CMAKE_CXX_EXTENSIONS OFF)

  set(DESTINATION DESTINATION .)
  set(QTC_SBOM_READY ON)

  include(Utils)
  include(QtCreatorIDEBranding)
  include(QtCreatorAPI)
  include(QtCreatorSbom)
  qtc_handle_compiler_cache_support()

  find_package(Qt6
    COMPONENTS Concurrent Core Gui Network PrintSupport Qml Quick Sql Widgets Xml
    REQUIRED
  )
  set(IS_STAND_ALONE_PUPPET_BUILD ON)

  qtc_setup_sbom()
  qtc_sbom_compute_cpe(project_cpe
      VENDOR "qt"
      PRODUCT "${PROJECT_NAME}"
      VERSION "${IDE_VERSION}"
  )
  set(QT_SBOM_LICENSE_DIRS "${CMAKE_CURRENT_SOURCE_DIR}/../../../LICENSES")
  qtc_sbom_begin_project(
    PURL_NAMESPACE "qt"
    PURL_NAME "${PROJECT_NAME}"
    CPE "${project_cpe}"
  )
endif()

add_qtc_executable(qmlpuppet
  ${DESTINATION}
  CONDITION TARGET Qt::Quick
  DEPENDS
    Qt::CorePrivate Qt::Widgets Qt::QmlPrivate
    Qt::QuickPrivate Qt::Network Qt::GuiPrivate
    QmlPuppetCommunication
  INCLUDES
    ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}
  SOURCES
    qmlpuppet/qmlpuppetmain.cpp
    qmlpuppet/qmlbase.h qmlpuppet/qmlbase.cpp
    qmlpuppet/qmlpuppet.h qmlpuppet/qmlpuppet.cpp
    qmlpuppet.qrc
  PROPERTIES
    OUTPUT_NAME qmlpuppet-${IDE_VERSION}
)

include(AutoInstallDesignerComponents.cmake)

if (IS_STAND_ALONE_PUPPET_BUILD)
    include(../../libs/qmlpuppetcommunication/QmlPuppetCommunication.cmake)
    configure_file(../../app/app_version.h.cmakein app/app_version.h ESCAPE_QUOTES)
else()
    extend_qtc_executable(qmlpuppet
      DEPENDS app_version
    )
endif()

extend_qtc_executable(qmlpuppet
  CONDITION Qt6_VERSION
  SOURCES
    editor3d_qt6.qrc
)

extend_qtc_executable(qmlpuppet
  CONDITION UNIX AND (NOT APPLE)
  DEPENDS rt
)

extend_qtc_executable(qmlpuppet
  SOURCES_PREFIX instances
  SOURCES
    nodeinstanceclientproxy.cpp nodeinstanceclientproxy.h
)

find_package(Qt6 COMPONENTS Quick3D QUIET)
extend_qtc_executable(qmlpuppet
  CONDITION TARGET Qt::Quick3D
  FEATURE_INFO "Qt Quick 3D support"
  DEPENDS Qt::Quick3D Qt::Quick3DPrivate
  DEFINES QUICK3D_MODULE

  SOURCES_PREFIX qmlpuppet/editor3d
  SOURCES
    generalhelper.cpp generalhelper.h
    mousearea3d.cpp mousearea3d.h
    geometrybase.cpp geometrybase.h
    camerageometry.cpp camerageometry.h
    lightgeometry.cpp lightgeometry.h
    gridgeometry.cpp gridgeometry.h
    selectionboxgeometry.cpp selectionboxgeometry.h
    linegeometry.cpp linegeometry.h
    icongizmoimageprovider.cpp icongizmoimageprovider.h
    boxgeometry.cpp boxgeometry.h
    lookatgeometry.cpp lookatgeometry.h
)

find_package(Qt6 COMPONENTS Quick3DAssetImport QUIET)
if (Qt6_VERSION VERSION_GREATER_EQUAL 6.9.0)
  find_package(Qt6 COMPONENTS Quick3DAssetImportPrivate QUIET)
endif()
extend_qtc_executable(qmlpuppet
  CONDITION TARGET Qt::Quick3DAssetImportPrivate
  FEATURE_INFO "Qt Quick 3D asset import"
  DEPENDS Qt::Quick3DAssetImportPrivate
  DEFINES IMPORT_QUICK3D_ASSETS
)

find_package(Qt6 COMPONENTS Quick3DParticles QUIET)
if (Qt6_VERSION VERSION_GREATER_EQUAL 6.9.0)
  find_package(Qt6 COMPONENTS Quick3DParticlesPrivate QUIET)
endif()
extend_qtc_executable(qmlpuppet
  CONDITION TARGET Qt::Quick3DParticles AND TARGET Qt::Quick3DParticlesPrivate
  FEATURE_INFO "Qt Quick 3D particles"
  DEPENDS Qt::Quick3DParticles Qt::Quick3DParticlesPrivate
  DEFINES QUICK3D_PARTICLES_MODULE
)

# Quick3DAssetUtils optionally depends on QuickTimeline, so find also it to make the CI build work
find_package(Qt6 COMPONENTS Quick3DAssetUtils QuickTimeline QUIET)
if (Qt6_VERSION VERSION_GREATER_EQUAL 6.9.0)
  find_package(Qt6 COMPONENTS Quick3DAssetUtilsPrivate QUIET)
endif()
extend_qtc_executable(qmlpuppet
  CONDITION TARGET Qt::Quick3DAssetUtilsPrivate
  FEATURE_INFO "Qt Quick 3D asset utils"
  DEPENDS Qt::Quick3DAssetUtilsPrivate
  DEFINES QUICK3D_ASSET_UTILS_MODULE
)

extend_qtc_executable(qmlpuppet
  SOURCES_PREFIX qmlpuppet/import3d
  SOURCES
    import3d.cpp import3d.h
)

extend_qtc_executable(qmlpuppet
  SOURCES_PREFIX qmlpuppet/renderer
  SOURCES
    qmlrenderer.cpp qmlrenderer.h
)

extend_qtc_executable(qmlpuppet
  SOURCES_PREFIX qmlpuppet/instances
  SOURCES
    anchorchangesnodeinstance.cpp anchorchangesnodeinstance.h
    behaviornodeinstance.cpp behaviornodeinstance.h
    childrenchangeeventfilter.cpp childrenchangeeventfilter.h
    componentnodeinstance.cpp componentnodeinstance.h
    dummycontextobject.cpp dummycontextobject.h
    dummynodeinstance.cpp dummynodeinstance.h
    layoutnodeinstance.cpp layoutnodeinstance.h
    nodeinstanceserver.cpp nodeinstanceserver.h
    nodeinstancesignalspy.cpp nodeinstancesignalspy.h
    objectnodeinstance.cpp objectnodeinstance.h
    positionernodeinstance.cpp positionernodeinstance.h
    qmlpropertychangesnodeinstance.cpp qmlpropertychangesnodeinstance.h
    qmlstatenodeinstance.cpp qmlstatenodeinstance.h
    qmltransitionnodeinstance.cpp qmltransitionnodeinstance.h
    qt3dpresentationnodeinstance.cpp qt3dpresentationnodeinstance.h
    qt5bakelightsnodeinstanceserver.cpp qt5bakelightsnodeinstanceserver.h
    qt5import3dnodeinstanceserver.cpp qt5import3dnodeinstanceserver.h
    qt5informationnodeinstanceserver.cpp qt5informationnodeinstanceserver.h
    qt5nodeinstanceclientproxy.cpp qt5nodeinstanceclientproxy.h
    qt5nodeinstanceserver.cpp qt5nodeinstanceserver.h
    qt5previewnodeinstanceserver.cpp qt5previewnodeinstanceserver.h
    qt5rendernodeinstanceserver.cpp qt5rendernodeinstanceserver.h
    qt5testnodeinstanceserver.cpp qt5testnodeinstanceserver.h
    quick3dmaterialnodeinstance.cpp quick3dmaterialnodeinstance.h
    quick3dnodeinstance.cpp quick3dnodeinstance.h
    quick3drenderablenodeinstance.cpp quick3drenderablenodeinstance.h
    quick3dtexturenodeinstance.cpp quick3dtexturenodeinstance.h
    quickitemnodeinstance.cpp quickitemnodeinstance.h
    servernodeinstance.cpp servernodeinstance.h
    qt5capturepreviewnodeinstanceserver.cpp qt5capturepreviewnodeinstanceserver.h
    nodeinstanceserverdispatcher.cpp nodeinstanceserverdispatcher.h
    capturenodeinstanceserverdispatcher.cpp capturenodeinstanceserverdispatcher.h
    viewconfig.cpp viewconfig.h
    animationdriver.cpp animationdriver.h
)

extend_qtc_executable(qmlpuppet
  SOURCES_PREFIX qmlprivategate
  SOURCES
    qmlprivategate.cpp qmlprivategate.h
)

if (DEFINED MULTILANGUAGE_SUPPORT_SUBDIRECTORY AND Qt6_VERSION VERSION_GREATER_EQUAL 6.2.1)
  add_subdirectory(${MULTILANGUAGE_SUPPORT_SUBDIRECTORY} multilanguagesupport_static_build)
endif()

extend_qtc_executable(qmlpuppet
    CONDITION TARGET QtCreator::multilanguage-support
    DEPENDS QtCreator::multilanguage-support
    FEATURE_INFO "multilanguage-support in qmlpuppet"
)

extend_qtc_executable(qmlpuppet
  PUBLIC_INCLUDES src/libs
)

extend_qtc_executable(qmlpuppet
  CONDITION TARGET Nanotrace
  DEPENDS Nanotrace
)

if (Qt6_VERSION VERSION_GREATER_EQUAL 6.4.0)
    extend_qtc_executable(qmlpuppet
      # QT_QML_DEBUG is disabled in release builds, but is necessary to have the preview debug channel
      DEFINES ENABLE_INTERNAL_QML_RUNTIME QT_QML_DEBUG
      PUBLIC_INCLUDES ${CMAKE_CURRENT_LIST_DIR}/qmlpuppet/runner
      SOURCES_PREFIX qmlpuppet/runner
      SOURCES
        qmlruntime.h qmlruntime.cpp
        qmlconfiguration.h loadwatcher.h
    )

    # Turn the tool into its own self-contained qml module
    qt_add_qml_module(qmlpuppet
        URI QmlRuntime.QmlConfiguration
        VERSION 1.0
        RESOURCE_PREFIX "/qt-project.org/imports"
    )
    if (QTC_STATIC_BUILD)
      qt_import_qml_plugins(qmlpuppet PATH_TO_SCAN ${SRCDIR})
    endif()
endif()


# add application icon
# IDE_LOGO_PATH in a default QtCreator build is empty, all icons are found by relative paths
# So we can not use the icon then.
if (TARGET qmlpuppet AND NOT "${IDE_LOGO_PATH}" STREQUAL "")
    if (WIN32)
      set(RC_APPLICATION_NAME "${IDE_DISPLAY_NAME}")
      set(RC_VERSION "${IDE_VERSION}.0")
      set(RC_VERSION_STRING "${IDE_VERSION_DISPLAY}")
      set(RC_COPYRIGHT "${IDE_COPYRIGHT}")
      set(RC_PUBLISHER "${IDE_PUBLISHER}")

      string(REPLACE " " "\\x20" RC_APPLICATION_NAME "${RC_APPLICATION_NAME}")
      string(REPLACE " " "\\x20" RC_PUBLISHER "${RC_PUBLISHER}")
      string(REPLACE " " "\\x20" RC_COPYRIGHT "${RC_COPYRIGHT}")
      string(REPLACE "." "," RC_VERSION "${RC_VERSION}")

      target_compile_definitions(qmlpuppet PRIVATE
        RC_PUBLISHER=${RC_PUBLISHER}
        RC_APPLICATION_NAME=${RC_APPLICATION_NAME}
        RC_VERSION=${RC_VERSION}
        RC_VERSION_STRING=${RC_VERSION_STRING}
        RC_COPYRIGHT=${RC_COPYRIGHT}
        RC_ICON_PATH=${IDE_ICON_PATH}
      )

      target_sources(qmlpuppet PRIVATE windows_application_icon/qmlpuppet.rc)
    endif()
endif()

if(IS_STAND_ALONE_PUPPET_BUILD)
  qtc_sbom_end_project()
endif()

=== tests/auto/qmldebug/CMakeLists.txt ===
add_qtc_test(tst_qmlevent
  DEPENDS QmlDebug
  SOURCES
    tst_qmlevent.cpp
    tst_qmlevent.h
)

add_qtc_test(tst_qmleventlocation
  DEPENDS QmlDebug
  SOURCES
    tst_qmleventlocation.cpp
    tst_qmleventlocation.h
)

add_qtc_test(tst_qmleventtype
  DEPENDS QmlDebug
  SOURCES
    tst_qmleventtype.cpp
    tst_qmleventtype.h
)

add_qtc_test(tst_qmlprofilertraceclient
  DEPENDS QmlDebug Utils Tracing Qt::Network
  SOURCES
    tst_qmlprofilertraceclient.cpp
    tst_qmlprofilertraceclient.h
    tests.qrc
)

=== tests/manual/devcontainer/CMakeLists.txt ===
add_qtc_test(tst_devcontainer
  MANUALTEST
  DEPENDS DevContainer QtTaskTree
  SOURCES tst_devcontainer.cpp
)

=== debian/changelog ===
qtcreator (19.0.0~rc1-1) experimental; urgency=medium

  * New upstream development release.

 -- Pino Toscano <pino@debian.org>  Thu, 26 Feb 2026 20:15:14 +0100

=== debian/control ===
Source: qtcreator
Section: devel
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Adam Majer <adamm@zombino.com>,
           Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>,
           Pino Toscano <pino@debian.org>,
Build-Depends: clang (>= 1:14~),
               clangd (>= 1:17~),
               cmake (>= 3.16~),
               debhelper-compat (= 13),
               libarchive-dev,
               libclang-dev (>= 1:14~),
               libdw-dev,
               libsecret-1-dev,
               libyaml-cpp-dev (>= 0.5~),
               libzstd-dev,
               llvm-dev (>= 1:14~),
               pkgconf,
               python3:any,
               qt6-base-dev (>= 6.7.3~),
               qt6-base-private-dev (>= 6.5.4~),
               qt6-charts-dev (>= 6.5.4~),
               qt6-declarative-dev (>= 6.5.4~),
               qt6-declarative-private-dev (>= 6.5.4~),
               qt6-quick3d-dev (>= 6.5.4~),
               qt6-quick3d-private-dev (>= 6.5.4~),
               qt6-quicktimeline-dev (>= 6.5.4~),
               qt6-networkauth-dev (>= 6.5.4~),
               qt6-serialport-dev (>= 6.5.4~),
               qt6-shadertools-dev (>= 6.5.4~),
               qt6-svg-dev (>= 6.5.4~),
               qt6-tools-dev (>= 6.5.4~),
               qt6-tools-private-dev (>= 6.5.4~),
               qt6-websockets-dev (>= 6.5.4~),
               xxd,
               zlib1g-dev,
Standards-Version: 4.7.3
Homepage: https://doc.qt.io/qt-5/topics-app-development.html
Vcs-Git: https://salsa.debian.org/qt-kde-team/qt/qtcreator.git -b experimental
Vcs-Browser: https://salsa.debian.org/qt-kde-team/qt/qtcreator/-/tree/experimental

Package: qtcreator
Architecture: any
Depends: clangd (>= 1:17~),
         libqt6sql6-sqlite,
         qml6-module-qtqml-models,
         qml6-module-qtqml-workerscript,
         qml6-module-qtquick-controls,
         qml6-module-qtquick-layouts,
         qml6-module-qtquick,
         qtcreator-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: clang-tidy,
            gdb,
            make,
            qml-qt6,
            qt6-qmltooling-plugins,
            qt6-base-dev,
            qtcreator-doc,
            qt6-declarative-dev-tools,
            qt6-tools-dev-tools,
            qt6-translations-l10n,
            xterm | x-terminal-emulator
Suggests: clazy (>= 1.5), cmake, g++, git, meson, subversion, valgrind,
          python3-pylsp,
Description: integrated development environment (IDE) for Qt
 Qt Creator is a cross-platform integrated development environment (IDE)
 designed to make development with the Qt application framework faster
 and easier.
 .
 It includes:
  * An advanced C++ code editor
  * Integrated GUI layout and forms designer
  * Project and build management tools
  * Integrated, context-sensitive help system
  * Visual debugger
  * Rapid code navigation tools
  * Supports multiple platforms
  * Qt Quick Designer

Package: qtcreator-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: application data for Qt Creator IDE
 This package contains architecture-independent data for Qt Creator IDE.

Package: qtcreator-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: qt6-image-formats-plugins,
         ${misc:Depends},
Description: documentation for Qt Creator IDE
 Qt Creator is a cross-platform integrated development environment (IDE)
 designed to make development with the Qt application framework faster
 and easier.
 .
 This package contains documentation for Qt Creator IDE.
